package global

import "github.com/kataras/iris/v12"

const (
	CODE_SUCCESS        = 2000 // 成功
	CODE_PARAM_ERROR    = 2001 //参数错误
	CODE_OPERATION_FAIL = 2010 //操作失败
)

type Response struct {
}

type ResponseOption func(*ResponseOptions)

type ResponseOptions struct {
	Code int         `json:"code"` // 状态码 200 成功 其它失败
	Data interface{} `json:"data"`
	Msg  string      `json:"msg"` // 消息
}

func WithCode (c int)ResponseOption{
	return func(r *ResponseOptions){
		r.Code = c
	}
}

func WithData (d interface{})ResponseOption{
	return func(r *ResponseOptions){
		r.Data = d
	}
}

func WithMsg (m string)ResponseOption{
	return func(r *ResponseOptions){
		r.Msg = m
	}
}


func (r *Response) ParamError(c iris.Context, msg ...interface{})  {
	
}

