package utils

import (
	"math/rand"
	"sync/atomic"
	"time"
)

var genRandCodeCount int64

// GenRandCode 生成随机码
func GenRandCode(inviteCodeLen int, targetKind int) string {
	atomic.AddInt64(&genRandCodeCount, 1)
	ikind, kinds, result := targetKind, [][]int{[]int{10, 48}, []int{26, 97}, []int{26, 65}}, make([]byte, inviteCodeLen)
	isAll := targetKind > 2 || targetKind < 0
	rand.Seed(time.Now().UnixNano() + genRandCodeCount)
	for i := 0; i < inviteCodeLen; i++ {
		if isAll {
			ikind = rand.Intn(3)
		}
		scope, base := kinds[ikind][0], kinds[ikind][1]
		result[i] = uint8(base + rand.Intn(scope))
	}
	return string(result)
}

// RandNum 生成[start,end)随机数
func RandNum(start, end int) int {
	if end < start {
		return 0
	}
	return rand.New(rand.NewSource(time.Now().UnixNano())).Intn(end-start) + start
}

func RandInt() int {
	rnd := rand.New(rand.NewSource(time.Now().UnixNano()))
	rand := int(rnd.Int31n(1000000))
	return rand
}
