package utils

import (
	"github.com/go-redis/redis"
	"go.uber.org/zap"
	"xiaoxiong/internal/global"
)

func InitRedis() *redis.Client {
	redisCfg := global.CONFIG.Redis
	client := redis.NewClient(&redis.Options{
		Addr:     redisCfg.Addr,
		Password: redisCfg.Password, // no password set
		DB:       redisCfg.DB,       // use default DB
	})
	pong, err := client.Ping().Result()
	if err != nil {
		global.Log.Error("redis connect ping failed, err:", zap.Any("err", err))
		panic(err)
		return nil
	} else {
		global.Log.Debug("redis connect ping response:", zap.String("pong", pong))
		return client
	}
}
