package taobao

import (
	"crypto/md5"
	"encoding/hex"
	"fmt"
	"net/url"
	"reflect"
	"sort"
	"strings"
	"time"
)

const TaobaoUrl = "http://gw.api.taobao.com/router/rest"

type CommonRequest struct {
	AppKey     string `json:"app_key"`
	V          string `json:"v"`
	Format     string `json:"format"`
	SignMethod string `json:"sign_method"`
	Method     string `json:"method"`
	Timestamp  string `json:"timestamp"`
	//PartnerId  string `json:"partner_id"`
	Sign string `json:"sign"`
}

func newCommonRequest(appKeyType int8) *CommonRequest {
	r := &CommonRequest{}

	var appKey string
	if appKeyType == 2 {
		appKey = "28173405"
	} else {
		appKey = "25623446"
	}
	r.AppKey = appKey
	r.V = "2.0"
	r.Format = "json"
	r.SignMethod = "md5"
	r.Timestamp = time.Now().Format("2006-01-02 15:04:05")

	return r
}

// 获取请求参数，公共参数在url中，业务参数post
func getPostData(c interface{}) (url.Values, url.Values) {
	t := reflect.TypeOf(c)
	v := reflect.ValueOf(c)

	res := url.Values{}
	get := url.Values{}
	for k := 0; k < t.NumField(); k++ {
		if _, ok := v.Field(k).Interface().(CommonRequest); ok {
			tt := reflect.TypeOf(v.Field(k).Interface())
			vv := reflect.ValueOf(v.Field(k).Interface())
			for kk := 0; kk < tt.NumField(); kk++ {
				if value, ok := vv.Field(kk).Interface().(string); ok {
					get.Set(tt.Field(kk).Tag.Get("json"), value)
				}
			}
		} else {
			if value, ok := v.Field(k).Interface().(string); ok {
				res.Set(t.Field(k).Tag.Get("json"), value)
			}
		}
	}

	return res, get
}

func generateSign(c interface{}, appKeyType int8) string {
	t := reflect.TypeOf(c)
	v := reflect.ValueOf(c)

	m := make(map[string]interface{})
	for k := 0; k < t.NumField(); k++ {
		if _, ok := v.Field(k).Interface().(CommonRequest); ok {
			tt := reflect.TypeOf(v.Field(k).Interface())
			vv := reflect.ValueOf(v.Field(k).Interface())
			for kk := 0; kk < tt.NumField(); kk++ {
				m[tt.Field(kk).Tag.Get("json")] = vv.Field(kk).Interface()
			}
		} else {
			m[t.Field(k).Tag.Get("json")] = v.Field(k).Interface()
		}
	}

	var arr []string
	for k, _ := range m {
		arr = append(arr, k)
	}
	sort.Strings(arr)

	var secret string
	if appKeyType == 2 {
		secret = "2299f4ce4d0c78ae5dec005f004e3444"
	} else {
		secret = "e835d91edfb5487125f754d831a02fba"
	}
	str := secret
	for _, k := range arr {
		if k != "sign" {
			str += fmt.Sprintf("%s%s", k, m[k])
		}
	}
	str += secret

	println("asdasdsad-" +str)

	h := md5.New()
	h.Write([]byte(str))
	return strings.ToTitle(hex.EncodeToString(h.Sum(nil)))
}

func httpPost(req interface{}, resp *interface{}) {

}
