package utils

import (
	"fmt"
	"github.com/spf13/viper"
	"xiaoxiong/internal/global"
)

func Viper() *viper.Viper {
	var err error
	config := viper.New()
	config.SetConfigType("yaml")
	config.SetConfigName("application")
	config.AddConfigPath("./")
	err = config.ReadInConfig()
	if err != nil {
		fmt.Println("error on parsing configuration file", err)
		return config
	}
	configs := config.AllSettings()
	for k, v := range configs {
		config.SetDefault(k, v)
	}
	config.SetConfigType("yaml")
	config.SetConfigName("application")
	config.AddConfigPath("./")
	err = config.ReadInConfig()
	if err != nil {
		return config
	}
	if err := config.Unmarshal(&global.CONFIG); err != nil {
		fmt.Println(err)
	}
	return config
}
